<Cabbage>
form caption("01_Tutorial") size(600, 400), guiMode("queue"), pluginId("def1")
keyboard bounds(8, 120, 600, 150)
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key-cps=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1

#include "creator.csdx"
#include "bbox.csdx"

instr simple, 1
    iWave cabbageGetValue "simplewave"
    iAtt cabbageGetValue "simpleattack"
    iDec cabbageGetValue "simpledecay"
    iSus cabbageGetValue "simplesustain"
    iRel cabbageGetValue "simplerelease"
    
    prints "p4: %d p5: %f w: %d a: %f d: %f s: %f r: %f\n", p4, p5, iWave, iAtt, iDec, iSus, iRel
    
    kPW = cabbageGetValue("simplepulsewidth")
    kEnv madsr iAtt, iDec, iSus, iRel
    
    aOut vco2 p5, p4, iWave, kPW
    outs aOut*kEnv, aOut*kEnv
endin

/*
this instr show the minimal way to create a set of sliders within a specific area.

it does not provide for the setting of defaults for the parameters (later), or
set the ranges for the sliders (also, later).
*/
instr simplebuilder
    iW cabbageGet "form", "width"
    iH cabbageGet "form", "height"
    
    x_flattenCode 1
    
    iBBox[] = fillarray(0, 0, iW, 100)
    
    SParams[] = fillarray("attack", "decay", "sustain", "release", "wave", "pulsewidth")
    
    iSliderCount = lenarray(SParams)
    iSliderBoxes[][] bb_split iBBox, iSliderCount, "v"
    printarray iSliderBoxes
    
    iCount = 0
    while iCount < iSliderCount do
        iBB[] = getrow(iSliderBoxes, iCount)
        cabbageCreate "rslider", sprintf("bounds(%d, %d, %d, %d) channel(\"simple%s\")", iBB[0], iBB[1], iBB[2], iBB[3], SParams[iCount])
        
;        x_create "rslider", fillarray(x_bounds(getrow(iSliderBoxes, iCount)), x_channel(sprintf("simple%s", SParams[iCount])))
        
        iCount = iCount + 1
    od
endin

instr simplebuilder2
    iW cabbageGet "form", "width"
    iH cabbageGet "form", "height"
    
    x_flattenCode 1
    
    iBBox[] = fillarray(0, 0, iW, 100)
    
    iSliderSize = 64
    SParams[] = fillarray("attack", "decay", "sustain", "release", "wave", "pulsewidth")
    SLabels[] = fillarray("att", "dec", "sus", "rel", "wave", "pw")
    
    iSliderCount = lenarray(SParams)
    iSliderBoxes[][] bb_split iBBox, iSliderCount, "v"
    printarray iSliderBoxes
    
    iCount = 0
    while iCount < iSliderCount do
        iBBox2[] = getrow(iSliderBoxes, iCount)
        
        iLabBB[] = bb_align(iBBox2, iSliderSize, 20, "ct")
        iRSlidBB[] = bb_align(iBBox2, iSliderSize, iSliderSize, "cb")
        cabbageCreate "label", sprintf("bounds(%d, %d, %d, %d) text(\"%s\")", iLabBB[0], iLabBB[1], iLabBB[2], iLabBB[3], SLabels[iCount])
        cabbageCreate "rslider", sprintf("bounds(%d, %d, %d, %d) channel(\"simple%s\")", iRSlidBB[0], iRSlidBB[1], iRSlidBB[2], iRSlidBB[3], SParams[iCount])
        
;        x_create "label",   fillarray(x_bounds(bb_align(iBBox2, iSliderSize, 20, "ct")), x_text(SLabels[iCount]))
;        x_create "rslider", fillarray(x_bounds(bb_align(iBBox2, iSliderSize, iSliderSize, "cb")), x_channel(sprintf("simple%s", SParams[iCount])))
        
        iCount = iCount + 1
    od
endin

/*
this opcode generates labels and knobs for every string in the SParams array.
it is assumed all other arrays match in size.
*/
opcode addWidgets, 0, i[]SSiiS[]S[]S[]
    iBBox[], SObj, SLabPos, iLabSize, iSlidSize, SParams[], SLabels[], SRanges[] xin
    SParent = SObj
    
    if strcmp(SLabPos, "top") == 0 || strcmp(SLabPos, "t") == 0 then
        SLabPos = "ct"
        SRSlPos = "cb"
    else
        SLabPos = "cb"
        SRSlPos = "ct"
    endif
    iSliderCount = lenarray(SParams)
    
    ; make the plant object
    cabbageCreate "image", sprintf("bounds(%d, %d, %d, %d) channel(\"%s\") colour(40, 40, 40, 40)", iBBox[0], iBBox[1], iBBox[2], iBBox[3], SObj)
;    x_create "image", fillarray(x_bounds(iBBox), x_channel(SObj), x_colour(40, 40, 40, 40)) ;; this we now refer to with SParent
    
    ; make the local bounding box
    iLocBox[] = fillarray(0, 0, iBBox[2], iBBox[3])
    iScaledBox[] = bb_inset(iLocBox, 4, 4)
    iSliderBoxes[][] bb_split iScaledBox, iSliderCount, "v"
    
    iCount = 0
    while iCount < iSliderCount do
        iBBox2[] = getrow(iSliderBoxes, iCount)
        
        iLabBB[] = bb_align(iBBox2, iSlidSize, iSlidSize, SLabPos)
        iRSlidBB[] = bb_align(iBBox2, iSlidSize, iSlidSize, SRSlPos)
        cabbageCreate "label", sprintf("bounds(%d, %d, %d, %d) text(\"%s\") parent(\"%s\")", iLabBB[0], iLabBB[1], iLabBB[2], iLabBB[3], SLabels[iCount], SParent)
        cabbageCreate "rslider", sprintf("bounds(%d, %d, %d, %d) channel(\"simple%s\") parent(\"%s\") %s", iRSlidBB[0], iRSlidBB[1], iRSlidBB[2], iRSlidBB[3], SParams[iCount], SParent, SRanges[iCount])
;        
;        x_create "label", fillarray(x_bounds(bb_align(iBBox2, iSlidSize, iLabSize, SLabPos)), x_text(SLabels[iCount]), x_parent(SParent))
;        x_create "rslider", fillarray(x_bounds(bb_align(iBBox2, iSlidSize, iSlidSize, SRSlPos)), x_channel(sprintf("%s%s", SObj, SParams[iCount])), x_parent(SParent), SRanges[iCount])
        
        iCount = iCount + 1
    od
endop

instr simplebuilder3
    iW cabbageGet "form", "width"
    iH cabbageGet "form", "height"
    
    x_flattenCode 1
    
    iBBox[] = fillarray(20, 20, iW - 40, 100)
    SParams[] = fillarray("attack", "decay", "sustain", "release", "wave", "pulsewidth")
    SLabels[] = fillarray("att", "dec", "sus", "rel", "wave", "pw")
    SRanges[] = fillarray(x_range(0, 1, .2, 1, 0.01),\
                            x_range(0, 1, .2, 1, 0.01),\
                            x_range(0, 1, .7, 1, 0.01),\
                            x_range(0, 1, .2, 1, 0.01),\
                            x_range(0, 2, 0, 1, 1),\
                            x_range(0, 1, .5, 1, 0.01))
    addWidgets(iBBox, "simple", "top", 20, 64, SParams, SLabels, SRanges)
endin

instr simplebuilder4
    iW cabbageGet "form", "width"
    iH cabbageGet "form", "height"
    
    x_flattenCode 1
    
    iBBox[] = fillarray(20, 20, iW - 40, 100)
    SParams[] = fillarray("attack", "decay", "sustain", "release")
    SLabels[] = fillarray("att", "dec", "sus", "rel")
    SRanges[] = fillarray(x_range(0, 1, .2, 1, 0.01),\
                            x_range(0, 1, .2, 1, 0.01),\
                            x_range(0, 1, .7, 1, 0.01),\
                            x_range(0, 1, .2, 1, 0.01))
    addWidgets(iBBox, "simple", "bottom", 20, 64, SParams, SLabels, SRanges)
endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
i "simplebuilder3" 0 0

f0 z
</CsScore>
</CsoundSynthesizer>
